<?php

/**
 * detalle_pago actions.
 *
 * @package    cobro_coactivo
 * @subpackage detalle_pago
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class detalle_pagoActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'CBR_DETALLE_PAGO',
        'CBR_PLANIFICA_FP',
        'CBR_FACILIDAD_PAGO_V',
        'CBR_PROCESO_COACTIVO',
        'CBR_AVOCA_CONOC',
        'CBR_REMISION_TITULO',
        'CBR_TITULO_MINERO_V',
        'CBR_ACTUALIZA_TITULO_V',
        'CA_DEBITO_COBRO_V',
        'CBR_TIPO_DOCUMENTO'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'CBR_PLANIFICA_FP' =>
        array(
            'id_planifica_fp' => 'CBR_DETALLE_PAGO'
        ),
        'CBR_FACILIDAD_PAGO_V' =>
        array(
            'id_facilidad_pago' => 'CBR_PLANIFICA_FP'
        ),
        'CBR_PROCESO_COACTIVO,LEFT' =>
        array(
            'id_proceso_coactivo' => 'CBR_FACILIDAD_PAGO_V'
        ),
        'CBR_AVOCA_CONOC,LEFT' =>
        array(
            'id_avoca_conoc' => 'CBR_FACILIDAD_PAGO_V'
        ),
        'CBR_REMISION_TITULO' =>
        array(
            'id_remision_titulo' => 'CBR_FACILIDAD_PAGO_V'
        ),
        'CBR_TITULO_MINERO_V,LEFT' =>
        array(
            'cod_titulo' => 'CBR_REMISION_TITULO'
        ),
        'CBR_ACTUALIZA_TITULO_V,LEFT' =>
        array(
            'cod_titulo' => 'CBR_REMISION_TITULO'
        ),
        'CA_DEBITO_COBRO_V' =>
        array(
            'id_debito' => 'CBR_DETALLE_PAGO'
        ),
        'CBR_TIPO_DOCUMENTO,LEFT' =>
        array(
            'id_tipo_documento' => 'CBR_AVOCA_CONOC'
        )
    );
    //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'CBR_DETALLE_PAGO' =>
        array(
            'id_detalle_pago' => 'id_detalle_pago',
            'id_planifica_fp' => 'id_planifica_fp',
            'id_debito' => 'id_debito'
        ),
        'CBR_PLANIFICA_FP' =>
        array(
            'id_facilidad_pago' => 'id_facilidad_pago',
            'fecha_inicio' => 'fecha_inicio',
            'valor_total' => 'valor_total',
            'descripcion' => 'descripcion',
            'numero_cuotas' => 'numero_cuotas'
        ),
        'CBR_FACILIDAD_PAGO_V' =>
        array(
            'id_remision_titulo' => 'id_remision_titulo',
            'id_proceso_coactivo' => 'id_proceso_coactivo',
            'id_avoca_conoc' => 'id_avoca_conoc',
            'fecha_registro' => 'fecha_registro'
        ),
        'CBR_PROCESO_COACTIVO' =>
        array(
            'no_proceso' => 'no_proceso',
            'fecha' => 'fecha_coactivo'
        ),
        'CBR_REMISION_TITULO' =>
        array(
            'numero_remision' => 'numero_remision',
            'anho_remision' => 'anho_remision',
            'fecha_remision' => 'fecha_remision',
            'estado' => 'estado',
            'cod_titulo' => 'cod_titulo',
            'anho_remision' => 'id_anhos'
        ),
        'CBR_AVOCA_CONOC' =>
        array(
            'no_auto' => 'no_auto',
            'fecha' => 'fecha_avoca',
            'id_tipo_documento' => 'id_tipo_documento'
        ),
        'CBR_TITULO_MINERO_V' =>
        array(
            'mineral' => 'mineral_deb',
            'id_debito' => 'id_debito_tit',
            'id_mineral' => 'id_mineral_deb'
        ),
        'CBR_ACTUALIZA_TITULO_V' =>
        array(
            'mineral' => 'mineral',
            'id_mineral' => 'id_mineral',
            'cod_mineral' => 'cod_mineral'
        ),
        'CA_DEBITO_COBRO_V' =>
        array(
            'sec_debito' => 'sec_debito',
            'fecha_proceso' => 'fecha_debito',
            'saldo_actual' => 'saldo'
        ),
        'CBR_TIPO_DOCUMENTO' =>
        array(
            'descripcion' => 'descripcion_tipdoc'
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(); //campos para el ordenamiento de la consulta

    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'CBR_DETALLE_PAGO' =>
        array(
            'id_detalle_pago,a' => array('!=' => array(-1)),
            'id_detalle_pago,b' => array('=' => array('id_detalle_pago')),
            'id_planifica_fp' => array('=' => array('id_planifica_fp')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(); // filtros de condicion or
    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;

    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_detalle_pago'; //identificador de la tabla
    protected $id_names = array('id_detalle_pago'); //llave primaria
    protected $field_names = array('id_planifica_fp', 'id_debito'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'CBR_DETALLE_PAGO'; //tabla en la cual se aplican los cambios 

    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_detalle_pago'; //identificador unico de la tabla

    protected function postprocessRequest($Action, \sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, \sfWebRequest $request) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function validateAdd(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;


        $id_planifica_fp = $request['id_planifica_fp'];
        $valor = $request['saldo_actual'];

        $sql = <<<EOD
select valor_total from cbr_planifica_fp where id_planifica_fp = $id_planifica_fp
EOD;

        $records = CN_TABLE::executeSQL($sql);
        $valor_fp = $records[0]['valor_total'];

        $sql = <<<EOD
    select sum(tab1.saldo_actual) valor from cbr_detalle_pago tab0 
    join ca_debito_cobro_v tab1 ON tab1.id_debito = tab0.id_debito
    where id_planifica_fp = $id_planifica_fp
EOD;

        $records = CN_TABLE::executeSQL($sql);
        $valor_detalle = $records[0]['valor'];

        $valor_comp = $valor + $valor_detalle;

        if ($valor_comp > $valor_fp) {
            $errors['mensaje'] = "El valor registrado es mayor al saldo del Acuerdo de Pago";
            $errors[
                    'servicio'] = "detalle_pago";
        }


        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateRemove(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateUpdate(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

}
